angular.module('beamng.apps')
.directive('engineThermalDebug', ['UiUnits', function (UiUnits) {
  return {
    templateUrl: 'modules/apps/EngineThermalDebug/app.html',
    replace: true,
    restrict: 'EA',
    scope: true,
    controller: ['$log', '$scope', 'bngApi', 'StreamsManager', function ($log, $scope, bngApi, StreamsManager) {
      var streamsList = ['engineThermalData'];
      StreamsManager.add(streamsList);
      $scope.$on('$destroy', function () {
        StreamsManager.remove(streamsList);
      });

      $scope.gearText = '';
      $scope.$on('streamsUpdate', function (event, data) {
        $scope.$evalAsync(function () {
          if (data.engineThermalData) {
            $scope.data = makeDataDisplayable(data.engineThermalData);
          } else {
            $scope.data = undefined;
          }
        });
      });

      function makeDataDisplayable (data) {
        return [{
              str: UiUnits.buildString('temperature', data.coolantTemperature, 0),
              name: 'Coolant',
              warn: (data.coolantTemperature > data.thermostatTemperature && data.coolantTemperature < 120 && data.thermostatStatus == 1),
              error: (data.coolantTemperature > 120)
          }, {
              str: UiUnits.buildString('temperature', data.oilTemperature, 0),
              name: 'Oil',
              warn: data.oilTemperature > 140,
              error: data.oilTemperature > 150
          }, {
              str: UiUnits.buildString('temperature', data.engineBlockTemperature, 0),
              name: 'Block',
          }, {
              str: UiUnits.buildString('temperature', data.cylinderWallTemperature, 0),
              name: 'Cylinder Wall',
          }, {
              str: UiUnits.buildString('temperature', data.exhaustTemperature, 0),
              name: 'Exhaust Manifold',
          }, {                      
          }
        ];
      }
    }]
  };
}]);
